#<profile4xi profile = "11" />  
# -------------------------------------------------------------------------------------------------
#<program4xi program = "zap0010three4xi.py">
#<abstract4xi abstract = "zaps to direction three"/>
#<verify4xi verification = "11" target = "zap2actor4xi.py"/>
#<refer4xi reference = "zap2actor4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'zap0010three4xi']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import itertools
import logging 
import os
import threading                
import signal
import sys
from math import pi
from math import sin
from math import cos 
from math import fabs
import weakref
import _thread
import _winapi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from zap2module4xi import ModuleKB2Zap4Xi
from print4xi      import print4xi
from time4xi       import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
# do NO define any globals for this kind of multiprocessing/thread module !!
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
ack2dragontrace = False 
#" 
#"/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "zap0010three4xi" usage = "target function for zap0000three4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
def zap0010three4xi(queue0010three, consumer_channel0010three, publisher_channel0010three, kb0010three):  
    '''
    returns layer 0010 of direction three
    ''' 
    # -------------------------------------------------------------------------------------------------
    # (Step 1/33)             
    # -------------------------------------------------------------------------------------------------   
    class2print  = 'zap0010three4xi'
    method2print = 'zap0010three4xi'
        
    # -------------------------------------------------------------------------------------------------
    # (Step 2/33)                      
    # -------------------------------------------------------------------------------------------------                                                               
    if ack2debug is True:
        print("\n (Step 2A/33) OF ZAP0010THREE4XI - STARTED TIME: ", time4xi())                                                     #  
        print("\n (Step 2B/33) OF ZAP0010THREE4XI -  QUEUE0010THREE: ", queue0010three)                                             # <queue4xi.Queue4Xi object at 0x04CDED30>  
        print("\n (Step 2C/33) OF ZAP0010THREE4XI -  CONSUME_CHANNEL0010THREE: ", consumer_channel0010three)                        # <read-write PipeConnection, handle 260>
        print("\n (Step 2D/33) OF ZAP0010THREE4XI -  PUBLISHER_CHANNEL0010THREE: ", publisher_channel0010three)                     # <read-write PipeConnection, handle 264>
        print("\n (Step 2E/33) OF ZAP0010THREE4XI -  KB0010THREE: ", kb0010three)                                                   
        # {'10x7y-58z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon10x7y-58z', 5: '#0080FF', 6: 74, 7: 3, 8: Decimal('59.2705660509'), 9: Decimal('49'), 10: 3, 11: '{started; ace-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'ace', 13: 2, 14: '-0x-0y-0z', 15: '24x28y-12z', 16: '11x44y-19z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '1x9y-2z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x9y-2z', 5: '#0080FF', 6: 37, 7: 3, 8: Decimal('9.2736184955'), 9: Decimal('0'), 10: 3, 11: '{(Step 2/3b) performed; init-zskeleton4xi-performed-by-init-zskeleton-of-ZSkeleton4Xi: function init_zskeleton4xi at 0x02A5F738; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'init_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '1x8y-28z', 16: '20x41y-18z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '1x7y-28z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x7y-28z', 5: '#0080FF', 6: 31, 7: 3, 8: Decimal('28.8790581564'), 9: Decimal('18'), 10: 3, 11: '{(Step 1/3b) passed; z-init-param1-passed-to-init-zskeleton-of-ZSkeleton4Xi: unified method initialization first time by yourDragonXi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'init_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '1x5y-69z', 16: '1x8y-28z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '0x53y-26z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x53y-26z', 5: '#0080FF', 6: 26, 7: 3, 8: Decimal('59.0338885726'), 9: Decimal('49'), 10: 3, 11: '{(Step 3/3a) activated; zskeleton2xi-of-ZSkeleton4Xi-activated: ; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z', 15: '0x4y-69z', 16: '0x7y-29z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '1x4y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x4y-69z', 5: '#0080FF', 6: 54, 7: 3, 8: Decimal('69.1230786351'), 9: Decimal('59'), 10: 3, 11: '{(Step 2/2) returning; get-zskeleton4xi-function-returning-by-get-zskeleton-of-ZSkeleton4Xi: function get_zskeleton4xi at 0x02A5F810; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '1x44y-21z', 16: '24x39y-17z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '0x4y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x4y-69z', 5: '#0080FF', 6: 25, 7: 3, 8: Decimal('69.1158447825'), 9: Decimal('59'), 10: 3, 11: '{(Step 2/3b) performed; init-zskeleton4xi-performed-by-init-of-ZSkeleton4Xi: function init_zskeleton4xi at 0x02A5F738; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z', 15: '0x3y-69z', 16: '0x53y-26z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '0x3y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x3y-69z', 5: '#0080FF', 6: 20, 7: 3, 8: Decimal('69.0651865993'), 9: Decimal('59'), 10: 3, 11: '{(Step 2/3a) passing; z-init-param1-passing-to-init-zskeleton4xi-by-init-of-ZSkeleton4Xi: None; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z', 15: '0x2y-69z', 16: '0x4y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '26x27y-12z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon26x27y-12z', 5: '#0080FF', 6: 59, 7: 3, 8: Decimal('39.3573373083'), 9: Decimal('29'), 10: 3, 11: "{sensing; ZSkeleton4Xi-sensing-by-sense-of-ZSkeleton4Xi: class 'zskeleton4xi.ZSkeleton4Xi'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'sense', 13: 2, 14: '-0x-0y-0z', 15: '24x39y-17z', 16: '26x64y-39z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '29x63y-38z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon29x63y-38z', 5: '#0080FF', 6: 45, 7: 3, 8: Decimal('79.0822356791'), 9: Decimal('69'), 10: 3, 11: '{(Step 1/3b) passed; z-set-param1-passed-to-set-zskeleton-of-ZSkeleton4Xi: unified method setting first time by yourDragonXi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'set_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '29x24y-11z', 16: '2x19y-4z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '18x42y-18z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon18x42y-18z', 5: '#0080FF', 6: 39, 7: 3, 8: Decimal('49.1121166312'), 9: Decimal('39'), 10: 3, 11: '{(Step 1/2) started; get-zskeleton-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '20x41y-18z', 16: '1x19y-4z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '13x0y-58z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon13x0y-58z', 5: '#0080FF', 6: 76, 7: 3, 8: Decimal('59.4390444069'), 9: Decimal('49'), 10: 3, 11: "{got; kb8xi-got-by-ace-of-ZSkeleton4Xi: {'object8xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'ace', 13: 2, 14: '-0x-0y-0z', 15: '11x44y-19z', 16: '13x44y-19z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '2x6y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon2x6y-69z', 5: '#0080FF', 6: 52, 7: 3, 8: Decimal('69.2892488053'), 9: Decimal('59'), 10: 3, 11: '{(Step 3/3) returning; set-zskeleton-of-ZSkeleton4Xi-returning: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'set_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '2x5y-69z', 16: '1x44y-21z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '22x65y-40z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon22x65y-40z', 5: '#0080FF', 6: 71, 7: 3, 8: Decimal('79.4292137692'), 9: Decimal('69'), 10: 3, 11: "{got; kb4xi-got-by-reason-of-ZSkeleton4Xi: {'object-reason-object4xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason', 13: 2, 14: '-0x-0y-0z', 15: '22x40y-17z', 16: '23x29y-13z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '0x0y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x0y-69z', 5: '#0080FF', 6: 16, 7: 3, 8: Decimal('69.0'), 9: Decimal('59'), 10: 3, 11: '{(Step 1/3b) borning; zskeleton2xi-of-ZSkeleton4Xi-borning: ; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z', 15: '0x0y-39z', 16: '0x19y-4z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '1x5y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x5y-69z', 5: '#0080FF', 6: 30, 7: 3, 8: Decimal('69.1881492743'), 9: Decimal('59'), 10: 3, 11: '{(Step 1/3a) started; init-zskeleton-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'init_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '0x9y-38z', 16: '1x7y-28z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '11x44y-19z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon11x44y-19z', 5: '#0080FF', 6: 75, 7: 3, 8: Decimal('49.1731634126'), 9: Decimal('39'), 10: 3, 11: "{acing; ZSkeleton4Xi-acing-by-ace-of-ZSkeleton4Xi: class 'zskeleton4xi.ZSkeleton4Xi'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'ace', 13: 2, 14: '-0x-0y-0z', 15: '10x7y-58z', 16: '13x0y-58z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '0x2y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x2y-69z', 5: '#0080FF', 6: 19, 7: 3, 8: Decimal('69.0289794217'), 9: Decimal('59'), 10: 3, 11: '{(Step 1/3e) passed; z-init-param1-passed-to-init-of-ZSkeleton4Xi: None; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z', 15: '0x1y-69z', 16: '0x3y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '0x8y-39z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x8y-39z', 5: '#0080FF', 6: 28, 7: 3, 8: Decimal('39.8120584748'), 9: Decimal('29'), 10: 3, 11: '{(Step 3/3c) shared; classvariable2z-shared-by-zskeleton2xi-of-ZSkeleton4Xi: None; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z', 15: '0x7y-29z', 16: '0x9y-38z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '15x43y-19z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon15x43y-19z', 5: '#0080FF', 6: 78, 7: 3, 8: Decimal('49.3457191659'), 9: Decimal('39'), 10: 3, 11: "{returning; kb8xi-returning-by-ace-of-ZSkeleton4Xi: {'time-ace-of-ZSkeleton4Xi': '18:58:34 11/11/10 Pacific Standard Time', 'object8xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'ace', 13: 2, 14: '-0x-0y-0z', 15: '13x44y-19z', 16: '+0x+0y+0z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '13x44y-19z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon13x44y-19z', 5: '#0080FF', 6: 77, 7: 3, 8: Decimal('49.6588360717'), 9: Decimal('39'), 10: 3, 11: "{aced; ZSkeleton4Xi-aced-by-ace-of-ZSkeleton4Xi: class 'zskeleton4xi.ZSkeleton4Xi'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'ace', 13: 2, 14: '-0x-0y-0z', 15: '13x0y-58z', 16: '15x43y-19z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '1x8y-28z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x8y-28z', 5: '#0080FF', 6: 32, 7: 3, 8: Decimal('29.1376045687'), 9: Decimal('19'), 10: 3, 11: '{(Step 2/3a) passing; z-init-param1-passing-to-init-zskeleton4xi-by-init-zskeleton-of-ZSkeleton4Xi: unified method initialization first time by yourDragonXi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'init_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '1x7y-28z', 16: '1x9y-2z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '27x26y-11z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon27x26y-11z', 5: '#0080FF', 6: 64, 7: 3, 8: Decimal('39.0640499692'), 9: Decimal('29'), 10: 3, 11: "{sensed; ZSkeleton4Xi-sensed-by-sense-of-ZSkeleton4Xi: class 'zskeleton4xi.ZSkeleton4Xi'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'sense', 13: 2, 14: '-0x-0y-0z', 15: '26x64y-39z', 16: '27x38y-16z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '0x1y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x1y-69z', 5: '#0080FF', 6: 18, 7: 3, 8: Decimal('69.0072459963'), 9: Decimal('59'), 10: 3, 11: '{(Step 1/3d) sharing; classvariable2z-sharing-by-zskeleton2xi-of-ZSkeleton4Xi: None; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z', 15: '0x19y-4z', 16: '0x2y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '1x44y-21z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x44y-21z', 5: '#0080FF', 6: 53, 7: 3, 8: Decimal('48.7647413609'), 9: Decimal('38'), 10: 3, 11: '{(Step 1/2) started; get-zskeleton-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '2x6y-69z', 16: '1x4y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '21x74y-45z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon21x74y-45z', 5: '#0080FF', 6: 66, 7: 3, 8: Decimal('89.1178994366'), 9: Decimal('79'), 10: 3, 11: '{started; reason-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason', 13: 2, 14: '-0x-0y-0z', 15: '27x38y-16z', 16: '22x40y-17z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '20x41y-18z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon20x41y-18z', 5: '#0080FF', 6: 38, 7: 3, 8: Decimal('49.040799341'), 9: Decimal('39'), 10: 3, 11: '{(Step 3/3) returning; init-zskeleton-of-ZSkeleton4Xi-returning: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'init_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '1x9y-2z', 16: '18x42y-18z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '26x64y-39z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon26x64y-39z', 5: '#0080FF', 6: 63, 7: 3, 8: Decimal('79.3284312211'), 9: Decimal('69'), 10: 3, 11: "{got; kb2xi-got-by-sense-of-ZSkeleton4Xi: {'object': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'sense', 13: 2, 14: '-0x-0y-0z', 15: '26x27y-12z', 16: '27x26y-11z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '0x0y-39z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x0y-39z', 5: '#0080FF', 6: 15, 7: 3, 8: Decimal('39.0'), 9: Decimal('29'), 10: 3, 11: '{(Step 1/3a) started; init-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z', 15: '-0x-0y-0z', 16: '0x0y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '0x7y-29z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x7y-29z', 5: '#0080FF', 6: 27, 7: 3, 8: Decimal('29.8328677804'), 9: Decimal('19'), 10: 3, 11: "{(Step 3/3b) inherited; object-inherited-by-zskeleton2xi-of-ZSkeleton4Xi: class 'object'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: '__init__', 13: 2, 14: '-0x-0y-0z', 15: '0x53y-26z', 16: '0x8y-39z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '0x19y-4z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x19y-4z', 5: '#0080FF', 6: 17, 7: 3, 8: Decimal('19.4164878389'), 9: Decimal('9'), 10: 3, 11: "{(Step 1/3c) inheriting; object-inheriting-by-zskeleton2xi-of-ZSkeleton4Xi: class 'object'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: '__init__', 13: 2, 14: '-0x-0y-0z', 15: '0x0y-69z', 16: '0x1y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '2x5y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon2x5y-69z', 5: '#0080FF', 6: 51, 7: 3, 8: Decimal('69.209825892'), 9: Decimal('59'), 10: 3, 11: '{(Step 2/3b) performed; set-zskeleton4xi-performed-by-set-zskeleton-of-ZSkeleton4Xi: function set_zskeleton4xi at 0x02A5F7C8; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'set_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '2x19y-4z', 16: '2x6y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '24x28y-12z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon24x28y-12z', 5: '#0080FF', 6: 73, 7: 3, 8: Decimal('38.7814388593'), 9: Decimal('28'), 10: 3, 11: "{returning; kb4xi-returning-by-reason-of-ZSkeleton4Xi: {'object-reason-object4xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0, 'time-reason-of-ZSkeleton4Xi': '18:58:34 11/11/10 Pacific Standard Time'}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason', 13: 2, 14: '-0x-0y-0z', 15: '23x29y-13z', 16: '10x7y-58z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '22x40y-17z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon22x40y-17z', 5: '#0080FF', 6: 67, 7: 3, 8: Decimal('48.7134478353'), 9: Decimal('38'), 10: 3, 11: "{reasoning; ZSkeleton4Xi-reasoning-by-reason-of-ZSkeleton4Xi: class 'zskeleton4xi.ZSkeleton4Xi'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason', 13: 2, 14: '-0x-0y-0z', 15: '21x74y-45z', 16: '22x65y-40z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '2x19y-4z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon2x19y-4z', 5: '#0080FF', 6: 46, 7: 3, 8: Decimal('19.5192212959'), 9: Decimal('9'), 10: 3, 11: '{(Step 2/3a) passing; z-set-param1-passing-to-set-zskeleton4xi-by-set-zskeleton-of-ZSkeleton4Xi: unified method setting first time by yourDragonXi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'set_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '29x63y-38z', 16: '2x5y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '29x24y-11z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon29x24y-11z', 5: '#0080FF', 6: 44, 7: 3, 8: Decimal('39.2173431023'), 9: Decimal('29'), 10: 3, 11: '{(Step 1/3a) started; set-zskeleton-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'set_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '1x19y-4z', 16: '29x63y-38z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '23x29y-13z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon23x29y-13z', 5: '#0080FF', 6: 72, 7: 3, 8: Decimal('39.2300904919'), 9: Decimal('29'), 10: 3, 11: "{reasoned; ZSkeleton4Xi-reasoned-by-reason-of-ZSkeleton4Xi: class 'zskeleton4xi.ZSkeleton4Xi'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason', 13: 2, 14: '-0x-0y-0z', 15: '22x65y-40z', 16: '24x28y-12z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '24x39y-17z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon24x39y-17z', 5: '#0080FF', 6: 58, 7: 3, 8: Decimal('48.8466989673'), 9: Decimal('38'), 10: 3, 11: '{started; sense-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'sense', 13: 2, 14: '-0x-0y-0z', 15: '1x4y-69z', 16: '26x27y-12z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '1x19y-4z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x19y-4z', 5: '#0080FF', 6: 40, 7: 3, 8: Decimal('19.4422220952'), 9: Decimal('9'), 10: 3, 11: '{(Step 2/2) returning; get-zskeleton4xi-function-returning-by-get-zskeleton-of-ZSkeleton4Xi: function get_zskeleton4xi at 0x02A5F810; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton', 13: 2, 14: '-0x-0y-0z', 15: '18x42y-18z', 16: '29x24y-11z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '0x9y-38z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x9y-38z', 5: '#0080FF', 6: 29, 7: 3, 8: Decimal('39.0512483795'), 9: Decimal('29'), 10: 3, 11: '{(Step 3/3d) returning time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z', 15: '0x8y-39z', 16: '1x5y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
        # '27x38y-16z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon27x38y-16z', 5: '#0080FF', 6: 65, 7: 3, 8: Decimal('49.2848861214'), 9: Decimal('39'), 10: 3, 11: "{returning; kb2xi-returning-by-sense-of-ZSkeleton4Xi: {'classvariable2z-of-ZSkeleton4Xi': None, 'object': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'sense', 13: 2, 14: '-0x-0y-0z', 15: '27x26y-11z', 16: '21x74y-45z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}}} 29x24y-11z

        
    message2print = "{(Step 2A/33) started" + "; zap0010three4xi-started: " + str(zap0010three4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              # 
        
    message2print = "{(Step 2B/33) passed" + "; queue0010three-passed-to-zap0010three4xi: " + str(queue0010three) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              # 
                  
    message2print = "{(Step 2C/33) passed" + "; consumer-channel0010three-passed-to-zap0010three4xi: " + str(consumer_channel0010three) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #    
    
    message2print = "{(Step 2D/33) passed" + "; publisher-channel0010three-passed-to-zap0010three4xi: " + str(publisher_channel0010three) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #          
    
    message2print = "{(Step 2E/33) passed" + "; kb0010three-passed-to-zap0010three4xi: " + str(kb0010three) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #         
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # (Step 3/33)
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if ack2debug is True:
        print("\n (Step 3/33) OF ZAP0010THREE4XI - TRYING TO PUT LAYER 0010 TO QUEUE0010THREE: ", queue0010three)                         # 
    message2print = "{(Step 3/33) using" + "; queue0010three-using-by-zap0010three4xi: " + str(queue0010three)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #  
            
    ack0010put4three = False                                                                                                                           

    # ------------------------------------------------------------------------------------- 
    # (Step 4/33) 
    # -------------------------------------------------------------------------------------                 

    # ------------------------------------------------------------------------------------- 
    # CONSTANTS VALID FOR ANY ZAP-KOWLEDGEBASE  
    # -------------------------------------------------------------------------------------     
    key2sense       = '2xi'
    key2reason      = '4xi'
    key2ace         = '8xi'
    key2direction   = 1
    key2distance    = 2
    key2layer       = 3
    
    key2area4layer  = 1
    key2color4layer = 2
    key2qty4layer   = 3
    key2area4node   = 4
    
    key2identity    = 4 
    key2color       = 5
    key2fire        = 6
    key2cluster     = 7
    key2ray         = 8
    key2deviation   = 9 
    key2super       = 10
    key2message     = 11
    key2actor       = 12
    key2type        = 13
    key2home        = 14
    key2previous    = 15
    key2next        = 16
    key2last        = 17
    key2first       = 18
    key2module      = 19
      
    # ------------------------------------------------------------------------------------- 
    # (Step 5/33) CONSTANTS VALID FOR LAYER 0010 OF DIRECTION THREE 
    # ------------------------------------------------------------------------------------- 
    direction0010sense4three = 3                                                                                                    # DIRECTION
    message2print = "{(Step 5A/33) set" + "; direction0010sense4three-set-by-zap0010three4xi to: " + str(direction0010sense4three)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #  
            
    distance0010sense4three  = 10                                                                                                   # DISTANCE = LAYER
    message2print = "{(Step 5B/33) set" + "; distance0010sense4three-set-by-zap0010three4xi to: " + str(distance0010sense4three)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #  
                                                                 
    # ------------------------------------------------------------------------------------- 
    # (Step 6/33) CREATE NEW KNOWLEDGEBASE FOR LAYER 0010 OF DIRECTION THREE 
    # -------------------------------------------------------------------------------------         
    keys0010three = kb0010three.keys()
    kb0010three2put = {}
    for key0010three in keys0010three:
        if ((kb0010three[key0010three] [key2sense] [key2distance] == distance0010sense4three) and (kb0010three[key0010three] [key2sense] [key2direction] == direction0010sense4three)):
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------             
            if ack2debug is True:
                print("\n (Step 6A0/33) OF ZAP0010THREE4XI - LEVEL NODE'S KEY: ", key0010three, " CONTENT: ", kb0010three[key0010three]) 
                # 
            message2print = "{(Step 6A0/33) set" + "; nodekey-set-by-zap0010three4xi to: " + str(key0010three)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                      # 13x44y-19z
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------         
            try:                                                                                                                    
                kb0010three2put [key0010three] = {}                                                                                 # SAVE THE LAYER OF THE REQUIRED DIRECTION
            except:
                print("\n (Step 6A/33) OF ZAP0010THREE4XI *** FAILED TO SET LAYER 0010 TO QUEUE0010THREE: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            try:         
                kb0010three2put [key0010three] [key2sense]  = {}                                                                    # SENSE
            except:
                print("\n (Step 6B/33) OF ZAP0010THREE4XI *** FAILED TO SET LAYER 0010 TO QUEUE0010THREE: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                   
            if ack2debug is True:
                print("\n (Step 6C/33) OF ZAP0010THREE4XI - TRYING TO SET DIRECTION AT: ", kb0010three [key0010three] [key2sense] )
                                                                                                                                    # 
            try:                             
                kb0010three2put [key0010three] [key2sense] [key2direction] = kb0010three [key0010three] [key2sense] [key2direction] # DIRECTION 
                message2print = "{(Step 6D/33) set" + "; direction-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2direction])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  # 
                         
            except:
                print("\n (Step 6E/33) OF ZAP0010THREE4XI *** FAILED TO SET DIRECTION AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6F/33) OF ZAP0010THREE4XI - TRYING TO SET DISTANCE AT: ", kb0010three [key0010three] [key2sense] )#                
            try:                             
                kb0010three2put [key0010three] [key2sense] [key2distance] = kb0010three [key0010three][key2sense] [key2distance]    # DISTANCE
                message2print = "{(Step 6G/33) set" + "; distance-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2distance])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  # 
            except:
                print("\n (Step 6B4B/33) OF ZAP0010THREE4XI *** FAILED TO SET DISTANCE AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B5A/33) OF ZAP0010THREE4XI - TRYING TO SET LAYER AT: ", kb0010three [key0010three] [key2sense] ) #        
            try:                             
                kb0010three2put [key0010three] [key2sense] [key2layer] = {}                                                         # LAYER
                message2print = "{(Step 6B5B/33) set" + "; layer-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2layer])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B5Z/33) OF ZAP0010THREE4XI *** FAILED TO SET LAYER AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B6A/33) OF ZAP0010THREE4XI - TRYING TO SET AREA FOR LAYER AT: ", kb0010three [key0010three]  [key2sense] [key2layer] )                   
            try:                                                                                                                    #                     
                kb0010three2put [key0010three] [key2sense] [key2layer] [key2area4layer] = kb0010three [key0010three] [key2sense] [key2layer] [key2area4layer] 
                                                                                                                                    # AREA2LAYER
                message2print = "{(Step 6B6B/33) set" + "; area2layer-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2layer] [key2area4layer])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #               
            except:
                print("\n (Step 6B6Z/33) OF ZAP0010THREE4XI *** FAILED TO SET AREA FOR LAYER AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B7A/33) OF ZAP0010THREE4XI - TRYING TO SET COLOR FOR LAYER AT: ", kb0010three [key0010three]  [key2sense] [key2layer]  )
                                                                                                                                    #                    
            try:                             
                kb0010three2put [key0010three] [key2sense] [key2layer] [key2color4layer] = kb0010three [key0010three] [key2sense] [key2layer] [key2color4layer]
                                                                                                                                    # 
                message2print = "{(Step 6B7B/33) set" + "; color2layer-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2layer] [key2color4layer])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #             
            except:
                print("\n (Step 6B7Z/33) OF ZAP0010THREE4XI *** FAILED TO SET COLOR FOR LAYER AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B8A/33) OF ZAP0010THREE4XI - TRYING TO SET QUANTITY FOR LAYER: ", kb0010three [key0010three]  [key2sense] [key2layer]  )
                                                                                                                                    #                         
            try:                             
                kb0010three2put [key0010three] [key2sense] [key2layer] [key2qty4layer] = kb0010three [key0010three] [key2sense] [key2layer] [key2qty4layer]
                                                                                                                                    # 
                message2print = "{(Step 6B8B/33) set" + "; qty2layer-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2layer] [key2qty4layer])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B8Z/33) OF ZAP0010THREE4XI *** FAILED TO SET QUANTITY FOR LAYER AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B9A/33) OF ZAP0010THREE4XI - TRYING TO SET AREA FOR NODE: ", kb0010three  [key0010three] [key2sense] [key2layer]  )
                                                                                                                                    #                           
            try:                             
                kb0010three2put [key0010three] [key2sense] [key2layer] [key2area4node] = kb0010three [key0010three] [key2sense] [key2layer] [key2area4node]
                                                                                                                                    # AREA2NODE
                message2print = "{(Step 6B9B/33) set" + "; area2node-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2layer] [key2area4node])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #              
            except:
                print("\n (Step 6B9Z/33) OF ZAP0010THREE4XI *** FAILED TO SET AREA FOR NODE AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B10A/33) OF ZAP0010THREE4XI - TRYING TO SET IDENTITY: ", kb0010three  [key0010three] [key2sense] )
                                                                                                                                    #                
            try:                              
                kb0010three2put [key0010three] [key2sense] [key2identity] = kb0010three[ key0010three] [key2sense] [key2identity]   # IDENTITY
                message2print = "{(Step 6B10B/33) set" + "; identity-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2identity])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B10Z/33) OF ZAP0010THREE4XI *** FAILED TO SET IDENTITY AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B11A/33) OF ZAP0010THREE4XI - TRYING TO SET COLOR: ", kb0010three [key0010three]  [key2sense] )     
                                                                                                                                    #                
            try:                              
                kb0010three2put [key0010three] [key2sense] [key2color] = kb0010three [key0010three]  [key2sense] [key2color]        # COLOR
                message2print = "{(Step 6B11B/33) set" + "; color-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2color])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B11Z/33) OF ZAP0010THREE4XI *** FAILED TO SET COLOR AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B12A/33) OF ZAP0010THREE4XI - TRYING TO SET FIRE: ", kb0010three [key0010three]  [key2sense] )# 
            try:                             
                kb0010three2put [key0010three] [key2sense] [key2fire] = kb0010three [key0010three]  [key2sense] [key2fire]          # FIRE 
                message2print = "{STEP 2B12A/33) set" + "; fire-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2fire])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  # 
                        
            except:
                print("\n (Step 6B12Z/33) OF ZAP0010THREE4XI *** FAILED TO SET FIRE AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B13A/33) OF ZAP0010THREE4XI - TRYING TO SET CLUSTER: ", kb0010three [key0010three]  [key2sense] )
                                                                                                                                    # 
                                  
            try:                             
                kb0010three2put [key0010three] [key2sense] [key2cluster] = kb0010three [key0010three]  [key2sense] [key2cluster]    # 
                message2print = "{(Step 6B13B/33) set" + "; cluster-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2cluster])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B13Z/33) OF ZAP0010THREE4XI *** FAILED TO SET CLUSTER AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B14A/33) OF ZAP0010THREE4XI - TRYING TO SET RAY: ", kb0010three [key0010three]  [key2sense] ) #             
            try:                             
                kb0010three2put[key0010three] [key2sense] [key2ray] = kb0010three [key0010three]  [key2sense] [key2ray]             # RAY 
                message2print = "{(Step 6B14B/33) set" + "; ray-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put[key0010three] [key2sense] [key2ray])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                
            except:
                print("\n (Step 6B14Z/33) OF ZAP0010THREE4XI *** FAILED TO SET RAY AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B15A/33) OF ZAP0010THREE4XI - TRYING TO SET DEVIATION: ", kb0010three [key0010three]  [key2sense] )
                                                                                                                                    #                  
            try:                             
                kb0010three2put [key0010three] [key2sense] [key2deviation] = kb0010three [key0010three]  [key2sense] [key2deviation]# DEVIATION
                message2print = "{(Step 6B15B/33) set" + "; deviation-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2deviation])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                
            except:
                print("\n (Step 6B15Z/33) OF ZAP0010THREE4XI *** FAILED TO SET DEVIATION AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B16A/33) OF ZAP0010THREE4XI - TRYING TO SET SUPER: ", kb0010three [key0010three]  [key2sense] )
                                                                                                                                    #                 
            try:                              
                kb0010three2put[key0010three] [key2sense] [key2super] = kb0010three [key0010three]  [key2sense] [key2super]         # SUPER
                message2print = "{(Step 6B16B/33) set" + "; super-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put[key0010three] [key2sense] [key2super])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                
            except:
                print("\n (Step 6B16Z/33) OF ZAP0010THREE4XI *** FAILED TO SET SUPER AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B17A/33) OF ZAP0010THREE4XI - TRYING TO SET MESSAGE: ", kb0010three [key0010three]  [key2sense] )
                                                                                                                                    #                
            try:                             
                kb0010three2put [key0010three] [key2sense] [key2message] = kb0010three [key0010three]  [key2sense] [key2message]    # MESSAGE
                message2print = "{(Step 6B17B/33) set" + "; message-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2message])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  # 
                                 
            except:
                print("\n (Step 6B17C/33) OF ZAP0010THREE4XI - TRYING TO GENERATE DUMMY MESSAGE TO: ", kb0010three [key0010three]  [key2sense])     
                try:
                                                                                                                                    # set default message
                    kb0010three2put [key0010three] [key2sense] [key2message] = "{(Step 6B17C/33) yielded" + "; key2message-yielded-by-zap0010three4xi: " + str(key2message)  + "; time: " + time4xi() + "}"
                    
                    message2print = "{(Step 6B17D/33) set" + "; message-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2message])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                except:    
                    print("\n (Step 6B17Z/33) OF ZAP0010three4XI *** FAILED TO SET MESSAGE AT LAYER 0010: ", key0010three) 
                                       
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B18A/33) OF ZAP0010THREE4XI - TRYING TO SET ACTOR: ", kb0010three [key0010three]  [key2sense] )
                                                                                                                                    #                   
            try:                             
                kb0010three2put [key0010three] [key2sense] [key2actor] = kb0010three [key0010three]  [key2sense] [key2actor]        # ACTOR 
                message2print = "{(Step 6B18B/33) set" + "; actor-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2actor])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #              
            except:
                try:
                    kb0010three2put [key0010three] [key2sense] [key2actor] = 'zap0010three4xi'                                      # THIS BECOMES THE ACTOR!
                    message2print = "{(Step 6B18C/33) set" + "; actor-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2actor])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                except:                            
                    print("\n (Step 6B18Z/33) OF ZAP0010THREE4XI *** FAILED TO SET ACTOR AT LAYER 0010 TO QUEUE0010TWO: ", key0010three)
                    # 
                
                
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B19A/33) OF ZAP0010THREE4XI - TRYING TO SET TYPE: ", kb0010three [key0010three]  [key2sense] )
                                                                                                                                    #                
            try:                             
                kb0010three2put [key0010three] [key2sense] [key2type] = kb0010three [key0010three]  [key2sense] [key2type]          # TYPE 
                message2print = "{(Step 6B19B/33) set" + "; type-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2type])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                
            except:
                try:
                    kb0010three2put [key0010three] [key2sense] [key2type] = 1                                                       # THIS IS function
                    message2print = "{(Step 6B19C/33) set" + "; type-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2type])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              #                
                except:
                    print("\n (Step 6B19Z/33) OF ZAP0010THREE4XI *** FAILED TO SET TYPE AT LAYER 0010 TO QUEUE0010TWO: ", key0010three)
                    # 
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B20A/33) OF ZAP0010THREE4XI - TRYING TO SET REASON: ", kb0010three [key0010three]  )           #                   
            try:                              
                kb0010three2put [key0010three] [key2reason] = kb0010three [key0010three] [key2reason]                               # REASON
                message2print = "{(Step 6B20B/33) set" + "; reason-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2reason])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B20Z/33) OF ZAP0010THREE4XI *** FAILED TO SET REASON AT LAYER 0010: ", key0010three)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B21A/33) OF ZAP0010THREE4XI - TRYING TO SET ACE: ", kb0010three [key0010three]   )            #              
            try:                             
                kb0010three2put [key0010three] [key2ace]    = kb0010three [key0010three] [key2ace]                                  # ACE
                message2print = "{(Step 6B21B/33) set" + "; ace-of-zap-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2ace])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                
            except:
                print("\n (Step 6B21Z/33) OF ZAP0010THREE4XI *** FAILED TO SET ACE AT LAYER 0010: ", key0010three)
                
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B22A/33) OF ZAP0010THREE4XI - TRYING TO SET MODULE: ", kb0010three [key0010three]  [key2sense] )
                                                                                                                                    # __init__-of-ZSkeleton4Xi; ace-of-ZSkeleton4Xi; init_zskeleton-of-ZSkeleton4Xi; get_zskeleton-of-ZSkeleton4Xi;                 
                                                                                              
            try:
                key2try = kb0010three [key0010three]  [key2sense] [key2actor]
                if ack2debug is True:
                    print("\n (Step 6B22B/33) OF ZAP0010THREE4XI - KEY2TRY: ", key2try)                                             # ace-of-ZSkeleton4Xi
                    
                kb0010three2put [key0010three] [key2sense] [key2module] = ModuleKB2Zap4Xi[key2try]                                   
                
                message2print = "{(Step 6B22C/33) set" + "; module-set-by-zap0010three4xi to: " + str(kb0010three2put [key0010three] [key2sense] [key2module])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  # zskeleton4xi.py 

            except:
                try:
                    kb0010three2put [key0010three] [key2sense] [key2module] = 'zap0010three4xi.py'                                  # THIS BECOMES THE MODULE IN EXCEPTIONS
                    print("\n (Step 6B22Z1/33) OF ZAP0010THREE4XI ** YIELDED - SET MODULE TO: ", kb0010three2put [key0010three] [key2sense] [key2module])
                    message2print = "{(Step 6B22Z1/33) yielded" + "; module-yielded-by-zap2actor4xi: " + str(kb0010three2put [key0010three] [key2sense] [key2module])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                          
                except:    
                    print("\n (Step 6B22Z2/33) OF ZAP0010THREE4XI *** FAILED TO SET MODULE AT LAYER 0010: ", key0010three)          #
                    #                                                                             
 
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
        else:
            pass
            
    # -------------------------------------------------------------------------------------------------
    # (Step 7/33) BUILD LINK LIST AT AT LAYER 0010 OF DIRECTION THREE 
    # -------------------------------------------------------------------------------------------------               
    if ack2debug is True:
        print("\n (Step 7A/33) OF ZAP0010THREE4XI - TRYING TO BUILD ORDER KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION THREE FROM : ", kb0010three2put)
                                                                                                                                    # 
                                                                                                                                    # 
                                                                                                                                    # 

    try:                             
        keys0010three2put = kb0010three2put.keys()                                                                                  # 
        kb0010link4three = {} 
        order2link = 1
        for key0010three2put in keys0010three2put:
            key0010navigation4three = kb0010three2put [key0010three2put] [key2sense] [key2fire]                                     # input nodes embed fire number 
            kb0010link4three [order2link] = {}
            kb0010link4three [order2link] [key0010three2put] = {}
            kb0010link4three [order2link] [key0010three2put] [1]    = 0                                                             # order                                                                                                                                 
            kb0010link4three [order2link] [key0010three2put] [2]    = '0x0y0z'                                                      # home                                                           
            kb0010link4three [order2link] [key0010three2put] [3]    = '0x0y0z'                                                      # previous
            kb0010link4three [order2link] [key0010three2put] [4]    = '0x0y0z'                                                      # next
            kb0010link4three [order2link] [key0010three2put] [5]    = '0x0y0z'                                                      # last
            kb0010link4three [order2link] [key0010three2put] [6]    = '0x0y0z'                                                      # first
            kb0010link4three [order2link] [key0010three2put] [7]    = 0                                                             # fire number
            order2link = order2link + 1
            
        keys0010link4three = kb0010link4three.keys()                                                                                # keys of input knowledgebase
        if ack2debug is True:
            for key0010link4three in sorted(keys0010link4three):                                                                    # keys of linklist
                if ack2debug is True:
                    print("\n (Step 7B/33) OF ZAP0010THREE4XI KB0010LINK4THREE[", key0010link4three, "]: ", kb0010link4three[key0010link4three])   
                                                                                                                                    # 
                                                                                                                                    # 
    except:
        print("\n (Step 7D/33) OF ZAP0010THREE4XI *** FAILED TO BUILD ORDER KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION THREE: ", kb0010link4three) 
        message2print = "{(Step 7E/33) failed" + "; kb0010link4three-failed-by-zap0010three4xi: " + str(kb0010link4three) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
    # -------------------------------------------------------------------------------------------------
    # (Step 8A/33) BUILD FIRE LIST
    # -------------------------------------------------------------------------------------------------                       
    if ack2debug is True:
        print("\n (Step 8A1/33) OF ZAP0010THREE4XI - TRYING BUILD FIRE KNOWLEDGEBASE")
    try:
        kb0010fire4three = {}
        keys0010three2put = kb0010three2put.keys()                                                                                  #            
        for key0010three2put in keys0010three2put:
            key0010fire4three = kb0010three2put [key0010three2put] [key2sense] [key2fire]                                           # 
            kb0010fire4three[key0010fire4three] = key0010three2put                                                                  # 
        if ack2debug is True:
            print("\n (Step 8A2/33) OF ZAP0010THREE4XI - BUILT FIRE KNOWLEDGEBASE: ", kb0010fire4three)                             #           
    except:
        print("\n (Step 8A3/33) OF ZAP0010THREE4XI *** FAILED BUILD FIRE KNOWLEDGEBASE")
        message2print = "{(Step 8Z/33) failed" + "; kb0010fire4three-failed-by-zap0010three4xi: " + str(kb0010fire4three) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
       
    # -----------------------------------------------------------------------------------------------------------------------------
    # (Step 8C/33) EMBED FIRES TO LINK LIST  
    # -----------------------------------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 8C1/33) OF ZAP0010THREE4XI - TRYING TO EMBED FIRES TO KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION THREE")     

    keys2fire = kb0010fire4three.keys()
    rank2xi = 1
    for key2fire in sorted(keys2fire):                                                                                              #                                                                    
        # -------------------------------------------------------------------------------------------------------------------------
        # 
        # -------------------------------------------------------------------------------------------------------------------------                                                                                     
        if ack2debug is True:
            print("\n (Step 8C5/33) OF ZAP0010THREE4XI - KEY2FIRE: ", key2fire)                                                     # 

        coordinate2rank = kb0010fire4three[key2fire]                                                                                #                                                             
        
        
        keys2link = kb0010link4three.keys()                                                                                           
        for keylink in keys2link:                                                                                                   # 
            try:
                if kb0010link4three [keylink] [coordinate2rank]  [7] == 0:            
                    kb0010link4three [keylink] [coordinate2rank] [7] = key2fire                                                     # 
                if kb0010link4three [keylink] [coordinate2rank]  [1] == 0:
                    kb0010link4three [keylink] [coordinate2rank] [1] = rank2xi                                                      # 
                    rank2xi = rank2xi + 1
                if ack2debug is True:    
                    print("\n (Step 8D10/33) OF ZAP0010THREE4XI - MATCH: UPDATED KB0010LINK4THREE: ", kb0010link4three)             # 
                                                                                                                                    # 
                                                                                                                                    # 
            except:
                pass               

    
    # ---------------------------------------------------------------------------------------------------------------------
    # (Step 8D/33) PRINT LINKING LIST WITH THREE FIRE EMBEDDED  
    # ---------------------------------------------------------------------------------------------------------------------                    
    if ack2debug is True:
        print("\n (Step 8D1/33) OF ZAP0010THREE4XI - TRYING TO PRINT LINKING LIST WITH THREE FIRE EMBEDDED ")   
        try: 
            print("\n (Step 8C7/33) OF ZAP0010THREE4XI - KB0010LINK4THREE: ", kb0010link4three)                                     # 
        except:                                                                                                                         
            print("\n (Step 8Z4/33) OF ZAP0010THREE4XI *** FAILED TO PRINT LINKING LIST WITH THREE FIRE EMBEDDED") 
                        
            
    # -------------------------------------------------------------------------------------------------
    # (Step 8E/33) EMBED FIRES TO KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION THREE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 8D1/33) OF ZAP0010THREE4XI - TRYING TO EMBED FIRES TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION THREE")      
                                                                                                                           
    keys0010three2put = kb0010three2put.keys()
                                               
    # -------------------------------------------------------------------------------------------------
    # THE LATEST VALUES TO BE CHANGED DURING WALKTROUGHS
    # -------------------------------------------------------------------------------------------------     
    origin2link         = '0x0y0z'                                                                                                  # link to origin
    home2link           = '-0x-0y-0z'                                                                                               # unresolved-home  
    previous2link       = '-0x-0y-0z'                                                                                               # unresolved-previous 
    next2link           = '+0x+0y+0z'                                                                                               # unresolved-next 
    first2link          = '+0x+0y+0z'                                                                                               # unresolved-first 
    last2link           = '+0x+0y+0z'                                                                                               # unresolved-last 
    max2last            = 0                                                                                                         # maximun order number for the last node - default 0

                                                                                                             
    # -------------------------------------------------------------------------------------------------
    # (Step 8E1/33) THE FIRST WALKTROUGH TO EMBED FIRES TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION THREE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 8E1a/33) OF ZAP0010THREE4XI - TRYING THE FIRST WALKTROUGH TO EMBED FIRES TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION THREE")               
    for key0010three2put in keys0010three2put:
        # -------------------------------------------------------------------------------------------------
        # KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION THREE
        # -------------------------------------------------------------------------------------------------                                                                                      
        if ack2debug is True:
            print("\n (Step 8E1b/33) OF ZAP0010THREE4XI KB0010LINK4THREE - KEY0010THREE2PUT: ", key0010three2put)                   # 
        keys2link = kb0010link4three.keys()
        for key2link in keys2link:
            if ack2debug is True:
                print("\n (Step 8E1c/33) OF ZAP0010THREE4XI KB0010LINK4THREE - KEY2LINK: ", key2link)                               # 
            # ---------------------------------------------------------------------------------------------
            # LINK LIST AT LAYER 0010 OF DIRECTION THREE
            # ---------------------------------------------------------------------------------------------          
            try:
                kb2check = kb0010link4three[key2link]
                keys2check = kb2check.keys()
                for key2check in keys2check:
                    # ---------------------------------------------------------------------------------------------
                    # NODE(S) OF LINK LIST AT LAYER 0010 OF DIRECTION THREE
                    # -------------------------------------------------------------------------------------------                   
                    if key2check == key0010three2put: 
                        if ack2debug is True:
                            print("\n (Step 8E1d/33) OF ZAP0010THREE4XI KB0010LINK4THREE - MATCH WITH KEY0010THREE2PUT: ", key0010three2put)
                                                                                                                                    #                                                                         
                        if kb0010link4three[key2link] [key0010three2put] [1] == 1:                                                  # the first nthree in fire order at this layer to required direction
                            if ack2debug is True:
                                print("\n (Step 8E1e/33) OF ZAP0010THREE4XI KB0010LINK4THREE - THE FIRT NODE: ", key0010three2put)  # 
                                  
                            # ---------------------------------------------------------------------------------
                            # SET LINKS OF THE FIRST NODE
                            # ---------------------------------------------------------------------------------                                                                              
                            first2link        = key0010three2put                                                                    # first-link points to this node                        
                            if ack2debug is True:
                                print("\n (Step 8E1f/33) OF ZAP0010THREE4XI KB0010LINK4THREE - SET FIRST2LINK TO: ", first2link)            
                                
                            # ---------------------------------------------------------------------------------
                            # EMBED LINKS OF THE FIRST NODE
                            # ---------------------------------------------------------------------------------                                                    
                            kb0010three2put [key0010three2put] [key2sense] [key2home]     = home2link                               # 
                                                                     
                                                     
                            # ---------------------------------------------------------------------------------
                            # UPDATE AFTER THE FIRST NODE
                            # --------------------------------------------------------------------------------- 
                            if kb0010link4three[key2link] [key0010three2put] [1] > max2last:
                                last2link    = key0010three2put                                                                     # 
                                max2last     = kb0010link4three[key2link] [key0010three2put] [1]                                    # 
                        else:
                            if ack2debug is True:
                                print("\n (Step 8E1g/33) OF ZAP0010THREE4XI KB0010LINK4THREE - THE ", kb0010link4three[key2link] [key0010three2put] [1], ". NODE: ", key0010three2put)
                                                                                                                                    # 
                                                                                                                                    #         
                            # ---------------------------------------------------------------------------------
                            # SET LINKS OF TYPICAL NODE
                            # ---------------------------------------------------------------------------------
                                                                                                                                    # 
                            
                            # ---------------------------------------------------------------------------------
                            # EMBED LINKS OF TYPICAL NODE
                            # ---------------------------------------------------------------------------------                                                    
                            kb0010three2put [key0010three2put] [key2sense] [key2home]     = home2link                               # only link to be updated for output!

                            # ---------------------------------------------------------------------------------
                            # UPDATE AFTER TYPICAL NODE 
                            # --------------------------------------------------------------------------------- 
                            if kb0010link4three[key2link] [key0010three2put] [1] > max2last:
                                last2link    = key0010three2put                                                                     # 
                                max2last     = kb0010link4three[key2link] [key0010three2put] [1]                                    #                   
                                                      
                           
                    else:
                        if ack2debug is True:
                            print("\n (Step 8E1h/33) OF ZAP0010THREE4XI KEY0010THREE2PUT - PASSED KEY2LINK: ", key2link, " WITH NODE: ", key0010three2put)              
            except:
                pass                                                                                                                # nodes with different links
    # -------------------------------------------------------------------------------------------------
    # 
    # -------------------------------------------------------------------------------------------------                                  
    if ack2debug is True:
        # key2home        = 14 [OK]
        print("\n (Step 8E1i/33) OF ZAP0010THREE4XI - LATEST FIRST: ", first2link)                                                  # 
        print("\n (Step 8E1j/33) OF ZAP0010THREE4XI - LATEST LAST: ", last2link)                                                    #                            
        print("\n (Step 8E1k/33) OF ZAP0010THREE4XI - LATEST MAX ORDER: ",max2last)                                                 #           
                
    # -------------------------------------------------------------------------------------------------
    # (Step 9/33) THE SECOND WALKTROUGH TO EMBED THE FIRST AND LAST LINK TO KNOWLEDGEBASE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 9A/33) OF ZAP0010THREE4XI - TRYING TO EMBED THE FIRST AND LAST LINK  TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION THREE")
    try:      
        for key0010three2put in keys0010three2put:
            # ---------------------------------------------------------------------------------------------
            # KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION THREE
            # ---------------------------------------------------------------------------------------------    
            kb0010three2put [key0010three2put] [key2sense] [key2first] = first2link
            kb0010three2put [key0010three2put] [key2sense] [key2last]  = last2link
        # ------------------------------------------------------------------------------------------------- 
        #
        # -------------------------------------------------------------------------------------------------             
        if ack2debug is True:    
            print("\n (Step 9B/33) OF ZAP0010THREE4XI - UPDATED THE FIRST AND LAST LINK TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION THREE")
            print("\n (Step 9C/33) OF ZAP0010THREE4XI - KB0010THREE2PUT: ", kb0010three2put)
            # 
 
    except:        
        print("\n (Step 9Z/33) OF ZAP0010THREE4XI *** FAILED TO EMBED THE FIRST AND LAST LINK  TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION THREE")
        message2print = "{(Step 9Z/33) failed" + "; kb0010three2put-failed-by-zap0010three4xi: " + str(kb0010three2put) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                  
    # -------------------------------------------------------------------------------------------------
    # (Step 10/33) THE THIRD WALKTROUGH TO EMBED PREVIOUS LINKS TO KNOWLEDGEBASE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 10A/33) OF ZAP0010THREE4XI - TRYING TO EMBED PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION THREE")
    try:    
        # 
        
        keys2link = kb0010link4three.keys()
        for key2link in keys2link:
            if ack2debug is True:
                print("\n (Step 10B/33) OF ZAP0010THREE4XI KB0010LINK4THREE - KEY2LINK: ", key2link)                                # 
            # ---------------------------------------------------------------------------------------------------
            # LINK LIST AT LAYER 0010 OF DIRECTION THREE
            # ---------------------------------------------------------------------------------------------------          
            try:
                kb2check = kb0010link4three[key2link]                                                                               # 
                keys2check = kb2check.keys()                                                                                        # 
                for key2check in keys2check: 
                                                                                                                                    #  
                    # -------------------------------------------------------------------------------------------
                    # PREVIOUS LINK
                    # -------------------------------------------------------------------------------------------                                                                                                                                             
                    if kb2check [key2check] [1] == 1:                                                                               # 1 = the first node
                        # ---------------------------------------------------------------------------------------
                        # FIRST NODE - UNRESOLVED-PREVIOUS FOR THE MAIN TO SOLVE FROM PREVIOUS LAYER LAST 
                        # ---------------------------------------------------------------------------------------
                        kb0010three2put [key2check] [key2sense] [key2previous] = previous2link                                      # 
                        if ack2debug is True:
                            print("\n (Step 10C/33) OF ZAP0010THREE4XI - PREVIOUS SET TO: ", previous2link, "  FOR THE FIRST NODE: ", key2check)
                                                                                                                                    # 
                    else:
                        # ---------------------------------------------------------------------------------------
                        # PREVIOUS TO OTHERS
                        # ---------------------------------------------------------------------------------------                 
                        order2previous = kb2check [key2check] [1] - 1                                                               # 
                        if ack2debug is True:
                            print("\n (Step 10D/33) OF ZAP0010THREE4XI ORDER OF PREVIOUS TO HUNT: ", order2previous, "  FOR NODE: ", key2check)
                                                                                                                                    # 
                                                                                                                                    # 
                        keys2hunt1 = kb0010link4three.keys()                                  
                        for key2hunt1 in keys2hunt1:                                                                                # 
                            # -----------------------------------------------------------------------------------
                            # HUNT PREVIOUS
                            # -----------------------------------------------------------------------------------
                            kb2check4hunt1 = kb0010link4three[key2hunt1]                                                            # 
                            keys2check4hunt1 = kb2check4hunt1.keys()                                                                # 
                            for key2check4hunt1 in keys2check4hunt1:
                                if kb2check4hunt1 [key2check4hunt1] [1] == order2previous:                                          # 
                                    kb0010three2put [key2check] [key2sense] [key2previous] = key2check4hunt1                        # 
                                    if ack2debug is True:
                                        print("\n (Step 10E/33) OF ZAP0010THREE4XI - PREVIOUS SET TO: ", key2check4hunt1, "  FOR NODE: ", key2check)
                                                                                                                                    # 
                                                                                                                                    # 
                            else:
                                pass

            except:        
                pass                    
        # ------------------------------------------------------------------------------------------------- 
        #
        # ------------------------------------------------------------------------------------------------- 
        # input link list:
        #                                          
        if ack2debug is True:    
            print("\n (Step 10B/33) OF ZAP0010THREE4XI - UPDATED PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION THREE")
            print("\n (Step 10C/33) OF ZAP0010THREE4XI - KB0010THREE2PUT: ", kb0010three2put)
            # 
            
    except:        
        print("\n (Step 10Z2/33) OF ZAP0010THREE4XI *** FAILED TO EMBED PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION THREE")
        message2print = "{(Step 10Z/33) failed" + "; kb0010three2put-failed-by-zap0010three4xi: " + str(kb0010three2put) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
    # -------------------------------------------------------------------------------------------------
    # (Step 11/33) THE THIRD WALKTROUGH TO EMBED NEXT LINKS TO KNOWLEDGEBASE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 11A/33) OF ZAP0010THREE4XI - TRYING TO EMBED NEXT LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION THREE")
    try:
        # input link list:    
        # 
        
        keys2link = kb0010link4three.keys()
        for key2link in keys2link:
            if ack2debug is True:
                print("\n (Step 11B/33) OF ZAP0010THREE4XI KB0010LINK4THREE - KEY2LINK: ", key2link)                                # 
            # ---------------------------------------------------------------------------------------------------
            # LINK LIST AT LAYER 0010 OF DIRECTION THREE
            # ---------------------------------------------------------------------------------------------------          
            try:
                kb2check = kb0010link4three[key2link]                                                                               # 
                keys2check = kb2check.keys()                                                                                        # 

                for key2check in keys2check:                 
                    # -------------------------------------------------------------------------------------------
                    # NEXT LINK
                    # -------------------------------------------------------------------------------------------                                 
                    if kb2check [key2check] [1] == max2last:
                        # ---------------------------------------------------------------------------------------
                        # LAST NODE - UNRESOLVED-NEXT FOR THE MAIN TO SOLVE FROM NEXT LAYER FIRST
                        # --------------------------------------------------------------------------------------- 
                        kb0010three2put [key2check] [key2sense] [key2next] = next2link                                              # 
                        if ack2debug is True:
                            print("\n (Step 11F/33) OF ZAP0010THREE4XI - NEXT SET TO: ", next2link, "  FOR LAST NODE: ", key2check)
                                                                                                                                    #                      
                    else:
                        # ---------------------------------------------------------------------------------------
                        # NEXT TO OTHERS
                        # ---------------------------------------------------------------------------------------                     
                        order2next = kb2check [key2check] [1] + 1                                                                   # 
                        if ack2debug is True:
                            print("\n (Step 11E/33) OF ZAP0010THREE4XI ORDER OF NEXT TO HUNT: ", order2next, "  FOR NODE: ", key2check)
                                                                                                                                    # 
                                                                                                                                    #                    
                        keys2hunt2 = kb0010link4three.keys()                         
                        for key2hunt2 in keys2hunt2:
                            # -----------------------------------------------------------------------------------
                            # HUNT NEXT
                            # -----------------------------------------------------------------------------------
                            kb2check4hunt2 = kb0010link4three[key2hunt2] 
                            keys2check4hunt2 = kb2check4hunt2.keys()
                            for key2check4hunt2 in keys2check4hunt2: 
                                if kb2check4hunt2 [key2check4hunt2] [1] == order2next:                                                
                                    kb0010three2put [key2check] [key2sense] [key2next] = key2check4hunt2                            # 
                                    if ack2debug is True:
                                        print("\n (Step 11G/33) OF ZAP0010THREE4XI - NEXT SET TO: ", key2check4hunt2, "  FOR NODE: ", key2check)
                                                                                                                                    #            
                                else:
                                    pass
            except:        
                pass                    
        # ------------------------------------------------------------------------------------------------- 
        #
        # ------------------------------------------------------------------------------------------------- 
        # order numbers:
        # {15: '0x0y-39z', 16: '0x0y-69z', 17: '0x19y-4z', 18: '0x1y-69z', 19: '0x2y-69z', 20: '0x3y-69z', 25: '0x4y-69z', 26: '0x53y-26z', 27: '0x7y-29z', 28: '0x8y-39z', 29: '0x9y-38z', 30: '1x5y-69z', 31: '1x7y-28z', 32: '1x8y-28z', 37: '1x9y-2z', 38: '20x41y-18z', 39: '18x42y-18z', 40: '1x19y-4z', 44: '29x24y-11z', 45: '29x63y-38z', 46: '2x19y-4z', 51: '2x5y-69z', 52: '2x6y-69z', 53: '1x44y-21z', 54: '1x4y-69z', 58: '24x39y-17z', 59: '26x27y-12z', 63: '26x64y-39z', 64: '27x26y-11z', 65: '27x38y-16z', 66: '21x74y-45z', 67: '22x40y-17z', 71: '22x65y-40z', 72: '23x29y-13z', 73: '24x28y-12z', 74: '10x7y-58z', 75: '11x44y-19z', 76: '13x0y-58z', 77: '13x44y-19z', 78: '15x43y-19z'}
         
        # keys:
        # key2direction   = 1,  key2distance    = 2,  key2layer       = 3   {key2area4layer  = 1, key2color4layer = 2, key2qty4layer   = 3, key2area4node   = 4}
        # key2identity    = 4,  key2color       = 5,  key2fire        = 6,  key2cluster     = 7,  key2ray         = 8, key2deviation   = 9, key2super       = 10
        # key2message     = 11, key2actor       = 12, key2type        = 13, key2home        = 14
        # key2previous    = 15, key2next        = 16, key2last        = 17, key2first       = 18, key2module      = 19
                                                  
        if ack2debug is True:    
            print("\n (Step 11B/33) OF ZAP0010THREE4XI - UPDATED NEXT LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION THREE")
            print("\n (Step 11C/33) OF ZAP0010THREE4XI - KB0010THREE2PUT: ", kb0010three2put)
            # {  '10x7y-58z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon10x7y-58z', 5: '#0080FF', 6: 74, 7: 3, 8: Decimal('59.2705660509'), 9: Decimal('49'), 10: 3, 11: '{started; ace-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'ace', 13: 2, 14: '-0x-0y-0z',
            #                         15: '24x28y-12z', 16: '11x44y-19z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '1x9y-2z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x9y-2z', 5: '#0080FF', 6: 37, 7: 3, 8: Decimal('9.2736184955'), 9: Decimal('0'), 10: 3, 11: '{(Step 2/3b) performed; init-zskeleton4xi-performed-by-init-zskeleton-of-ZSkeleton4Xi: function init_zskeleton4xi at 0x02A5F738; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'init_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '1x8y-28z', 16: '20x41y-18z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '1x7y-28z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x7y-28z', 5: '#0080FF', 6: 31, 7: 3, 8: Decimal('28.8790581564'), 9: Decimal('18'), 10: 3, 11: '{(Step 1/3b) passed; z-init-param1-passed-to-init-zskeleton-of-ZSkeleton4Xi: unified method initialization first time by yourDragonXi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'init_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '1x5y-69z', 16: '1x8y-28z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '0x53y-26z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x53y-26z', 5: '#0080FF', 6: 26, 7: 3, 8: Decimal('59.0338885726'), 9: Decimal('49'), 10: 3, 11: '{(Step 3/3a) activated; zskeleton2xi-of-ZSkeleton4Xi-activated: ; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z',
            #                         15: '0x4y-69z', 16: '0x7y-29z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '1x4y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x4y-69z', 5: '#0080FF', 6: 54, 7: 3, 8: Decimal('69.1230786351'), 9: Decimal('59'), 10: 3, 11: '{(Step 2/2) returning; get-zskeleton4xi-function-returning-by-get-zskeleton-of-ZSkeleton4Xi: function get_zskeleton4xi at 0x02A5F810; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '1x44y-21z', 16: '24x39y-17z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '0x4y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x4y-69z', 5: '#0080FF', 6: 25, 7: 3, 8: Decimal('69.1158447825'), 9: Decimal('59'), 10: 3, 11: '{(Step 2/3b) performed; init-zskeleton4xi-performed-by-init-of-ZSkeleton4Xi: function init_zskeleton4xi at 0x02A5F738; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z',
            #                         15: '0x3y-69z', 16: '0x53y-26z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '0x3y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x3y-69z', 5: '#0080FF', 6: 20, 7: 3, 8: Decimal('69.0651865993'), 9: Decimal('59'), 10: 3, 11: '{(Step 2/3a) passing; z-init-param1-passing-to-init-zskeleton4xi-by-init-of-ZSkeleton4Xi: None; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z',
            #                         15: '0x2y-69z', 16: '0x4y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '26x27y-12z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon26x27y-12z', 5: '#0080FF', 6: 59, 7: 3, 8: Decimal('39.3573373083'), 9: Decimal('29'), 10: 3, 11: "{sensing; ZSkeleton4Xi-sensing-by-sense-of-ZSkeleton4Xi: class 'zskeleton4xi.ZSkeleton4Xi'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'sense', 13: 2, 14: '-0x-0y-0z',
            #                         15: '24x39y-17z', 16: '26x64y-39z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '29x63y-38z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon29x63y-38z', 5: '#0080FF', 6: 45, 7: 3, 8: Decimal('79.0822356791'), 9: Decimal('69'), 10: 3, 11: '{(Step 1/3b) passed; z-set-param1-passed-to-set-zskeleton-of-ZSkeleton4Xi: unified method setting first time by yourDragonXi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'set_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '29x24y-11z', 16: '2x19y-4z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '18x42y-18z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon18x42y-18z', 5: '#0080FF', 6: 39, 7: 3, 8: Decimal('49.1121166312'), 9: Decimal('39'), 10: 3, 11: '{(Step 1/2) started; get-zskeleton-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '20x41y-18z', 16: '1x19y-4z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '13x0y-58z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon13x0y-58z', 5: '#0080FF', 6: 76, 7: 3, 8: Decimal('59.4390444069'), 9: Decimal('49'), 10: 3, 11: "{got; kb8xi-got-by-ace-of-ZSkeleton4Xi: {'object8xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'ace', 13: 2, 14: '-0x-0y-0z',
            #                         15: '11x44y-19z', 16: '13x44y-19z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '2x6y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon2x6y-69z', 5: '#0080FF', 6: 52, 7: 3, 8: Decimal('69.2892488053'), 9: Decimal('59'), 10: 3, 11: '{(Step 3/3) returning; set-zskeleton-of-ZSkeleton4Xi-returning: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'set_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '2x5y-69z', 16: '1x44y-21z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '22x65y-40z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon22x65y-40z', 5: '#0080FF', 6: 71, 7: 3, 8: Decimal('79.4292137692'), 9: Decimal('69'), 10: 3, 11: "{got; kb4xi-got-by-reason-of-ZSkeleton4Xi: {'object-reason-object4xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason', 13: 2, 14: '-0x-0y-0z',
            #                         15: '22x40y-17z', 16: '23x29y-13z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '0x0y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x0y-69z', 5: '#0080FF', 6: 16, 7: 3, 8: Decimal('69.0'), 9: Decimal('59'), 10: 3, 11: '{(Step 1/3b) borning; zskeleton2xi-of-ZSkeleton4Xi-borning: ; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z',
            #                         15: '0x0y-39z', 16: '0x19y-4z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '1x5y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x5y-69z', 5: '#0080FF', 6: 30, 7: 3, 8: Decimal('69.1881492743'), 9: Decimal('59'), 10: 3, 11: '{(Step 1/3a) started; init-zskeleton-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'init_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '0x9y-38z', 16: '1x7y-28z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '11x44y-19z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon11x44y-19z', 5: '#0080FF', 6: 75, 7: 3, 8: Decimal('49.1731634126'), 9: Decimal('39'), 10: 3, 11: "{acing; ZSkeleton4Xi-acing-by-ace-of-ZSkeleton4Xi: class 'zskeleton4xi.ZSkeleton4Xi'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'ace', 13: 2, 14: '-0x-0y-0z',
            #                         15: '10x7y-58z', 16: '13x0y-58z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '0x2y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x2y-69z', 5: '#0080FF', 6: 19, 7: 3, 8: Decimal('69.0289794217'), 9: Decimal('59'), 10: 3, 11: '{(Step 1/3e) passed; z-init-param1-passed-to-init-of-ZSkeleton4Xi: None; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z',
            #                         15: '0x1y-69z', 16: '0x3y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '0x8y-39z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x8y-39z', 5: '#0080FF', 6: 28, 7: 3, 8: Decimal('39.8120584748'), 9: Decimal('29'), 10: 3, 11: '{(Step 3/3c) shared; classvariable2z-shared-by-zskeleton2xi-of-ZSkeleton4Xi: None; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z',
            #                         15: '0x7y-29z', 16: '0x9y-38z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '15x43y-19z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon15x43y-19z', 5: '#0080FF', 6: 78, 7: 3, 8: Decimal('49.3457191659'), 9: Decimal('39'), 10: 3, 11: "{returning; kb8xi-returning-by-ace-of-ZSkeleton4Xi: {'time-ace-of-ZSkeleton4Xi': '18:58:34 11/11/10 Pacific Standard Time', 'object8xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'ace', 13: 2, 14: '-0x-0y-0z',
            #                         15: '13x44y-19z', 16: '+0x+0y+0z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '13x44y-19z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon13x44y-19z', 5: '#0080FF', 6: 77, 7: 3, 8: Decimal('49.6588360717'), 9: Decimal('39'), 10: 3, 11: "{aced; ZSkeleton4Xi-aced-by-ace-of-ZSkeleton4Xi: class 'zskeleton4xi.ZSkeleton4Xi'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'ace', 13: 2, 14: '-0x-0y-0z',
            #                         15: '13x0y-58z', 16: '15x43y-19z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '1x8y-28z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x8y-28z', 5: '#0080FF', 6: 32, 7: 3, 8: Decimal('29.1376045687'), 9: Decimal('19'), 10: 3, 11: '{(Step 2/3a) passing; z-init-param1-passing-to-init-zskeleton4xi-by-init-zskeleton-of-ZSkeleton4Xi: unified method initialization first time by yourDragonXi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'init_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '1x7y-28z', 16: '1x9y-2z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '27x26y-11z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon27x26y-11z', 5: '#0080FF', 6: 64, 7: 3, 8: Decimal('39.0640499692'), 9: Decimal('29'), 10: 3, 11: "{sensed; ZSkeleton4Xi-sensed-by-sense-of-ZSkeleton4Xi: class 'zskeleton4xi.ZSkeleton4Xi'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'sense', 13: 2, 14: '-0x-0y-0z',
            #                         15: '26x64y-39z', 16: '27x38y-16z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '0x1y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x1y-69z', 5: '#0080FF', 6: 18, 7: 3, 8: Decimal('69.0072459963'), 9: Decimal('59'), 10: 3, 11: '{(Step 1/3d) sharing; classvariable2z-sharing-by-zskeleton2xi-of-ZSkeleton4Xi: None; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z',
            #                         15: '0x19y-4z', 16: '0x2y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '1x44y-21z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x44y-21z', 5: '#0080FF', 6: 53, 7: 3, 8: Decimal('48.7647413609'), 9: Decimal('38'), 10: 3, 11: '{(Step 1/2) started; get-zskeleton-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '2x6y-69z', 16: '1x4y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '21x74y-45z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon21x74y-45z', 5: '#0080FF', 6: 66, 7: 3, 8: Decimal('89.1178994366'), 9: Decimal('79'), 10: 3, 11: '{started; reason-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason', 13: 2, 14: '-0x-0y-0z',
            #                         15: '27x38y-16z', 16: '22x40y-17z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '20x41y-18z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon20x41y-18z', 5: '#0080FF', 6: 38, 7: 3, 8: Decimal('49.040799341'), 9: Decimal('39'), 10: 3, 11: '{(Step 3/3) returning; init-zskeleton-of-ZSkeleton4Xi-returning: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'init_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '1x9y-2z', 16: '18x42y-18z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '26x64y-39z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon26x64y-39z', 5: '#0080FF', 6: 63, 7: 3, 8: Decimal('79.3284312211'), 9: Decimal('69'), 10: 3, 11: "{got; kb2xi-got-by-sense-of-ZSkeleton4Xi: {'object': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'sense', 13: 2, 14: '-0x-0y-0z',
            #                         15: '26x27y-12z', 16: '27x26y-11z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '0x0y-39z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x0y-39z', 5: '#0080FF', 6: 15, 7: 3, 8: Decimal('39.0'), 9: Decimal('29'), 10: 3, 11: '{(Step 1/3a) started; init-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z',
            #                         15: '-0x-0y-0z', 16: '0x0y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '0x7y-29z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x7y-29z', 5: '#0080FF', 6: 27, 7: 3, 8: Decimal('29.8328677804'), 9: Decimal('19'), 10: 3, 11: "{(Step 3/3b) inherited; object-inherited-by-zskeleton2xi-of-ZSkeleton4Xi: class 'object'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: '__init__', 13: 2, 14: '-0x-0y-0z',
            #                         15: '0x53y-26z', 16: '0x8y-39z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '0x19y-4z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x19y-4z', 5: '#0080FF', 6: 17, 7: 3, 8: Decimal('19.4164878389'), 9: Decimal('9'), 10: 3, 11: "{(Step 1/3c) inheriting; object-inheriting-by-zskeleton2xi-of-ZSkeleton4Xi: class 'object'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: '__init__', 13: 2, 14: '-0x-0y-0z',
            #                         15: '0x0y-69z', 16: '0x1y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '2x5y-69z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon2x5y-69z', 5: '#0080FF', 6: 51, 7: 3, 8: Decimal('69.209825892'), 9: Decimal('59'), 10: 3, 11: '{(Step 2/3b) performed; set-zskeleton4xi-performed-by-set-zskeleton-of-ZSkeleton4Xi: function set_zskeleton4xi at 0x02A5F7C8; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'set_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '2x19y-4z', 16: '2x6y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '24x28y-12z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon24x28y-12z', 5: '#0080FF', 6: 73, 7: 3, 8: Decimal('38.7814388593'), 9: Decimal('28'), 10: 3, 11: "{returning; kb4xi-returning-by-reason-of-ZSkeleton4Xi: {'object-reason-object4xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0, 'time-reason-of-ZSkeleton4Xi': '18:58:34 11/11/10 Pacific Standard Time'}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason', 13: 2, 14: '-0x-0y-0z',
            #                         15: '23x29y-13z', 16: '10x7y-58z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '22x40y-17z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon22x40y-17z', 5: '#0080FF', 6: 67, 7: 3, 8: Decimal('48.7134478353'), 9: Decimal('38'), 10: 3, 11: "{reasoning; ZSkeleton4Xi-reasoning-by-reason-of-ZSkeleton4Xi: class 'zskeleton4xi.ZSkeleton4Xi'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason', 13: 2, 14: '-0x-0y-0z',
            #                         15: '21x74y-45z', 16: '22x65y-40z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '2x19y-4z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon2x19y-4z', 5: '#0080FF', 6: 46, 7: 3, 8: Decimal('19.5192212959'), 9: Decimal('9'), 10: 3, 11: '{(Step 2/3a) passing; z-set-param1-passing-to-set-zskeleton4xi-by-set-zskeleton-of-ZSkeleton4Xi: unified method setting first time by yourDragonXi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'set_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '29x63y-38z', 16: '2x5y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '29x24y-11z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon29x24y-11z', 5: '#0080FF', 6: 44, 7: 3, 8: Decimal('39.2173431023'), 9: Decimal('29'), 10: 3, 11: '{(Step 1/3a) started; set-zskeleton-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'set_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '1x19y-4z', 16: '29x63y-38z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '23x29y-13z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon23x29y-13z', 5: '#0080FF', 6: 72, 7: 3, 8: Decimal('39.2300904919'), 9: Decimal('29'), 10: 3, 11: "{reasoned; ZSkeleton4Xi-reasoned-by-reason-of-ZSkeleton4Xi: class 'zskeleton4xi.ZSkeleton4Xi'; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason', 13: 2, 14: '-0x-0y-0z',
            #                         15: '22x65y-40z', 16: '24x28y-12z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '24x39y-17z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon24x39y-17z', 5: '#0080FF', 6: 58, 7: 3, 8: Decimal('48.8466989673'), 9: Decimal('38'), 10: 3, 11: '{started; sense-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'sense', 13: 2, 14: '-0x-0y-0z',
            #                         15: '1x4y-69z', 16: '26x27y-12z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '1x19y-4z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon1x19y-4z', 5: '#0080FF', 6: 40, 7: 3, 8: Decimal('19.4422220952'), 9: Decimal('9'), 10: 3, 11: '{(Step 2/2) returning; get-zskeleton4xi-function-returning-by-get-zskeleton-of-ZSkeleton4Xi: function get_zskeleton4xi at 0x02A5F810; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton', 13: 2, 14: '-0x-0y-0z',
            #                         15: '18x42y-18z', 16: '29x24y-11z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '0x9y-38z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon0x9y-38z', 5: '#0080FF', 6: 29, 7: 3, 8: Decimal('39.0512483795'), 9: Decimal('29'), 10: 3, 11: '{(Step 3/3d) returning time: 18:58:34 11/11/10 Pacific Standard Time}', 12: '__init__', 13: 2, 14: '-0x-0y-0z',
            #                         15: '0x8y-39z', 16: '1x5y-69z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}},
            #    '27x38y-16z': {'2xi': {1: 3, 2: 10, 3: {1: 157.07963267948966, 2: '#C3BDB7', 3: 40, 4: 3.9269908169872414}, 4: 'dragon27x38y-16z', 5: '#0080FF', 6: 65, 7: 3, 8: Decimal('49.2848861214'), 9: Decimal('39'), 10: 3, 11: "{returning; kb2xi-returning-by-sense-of-ZSkeleton4Xi: {'classvariable2z-of-ZSkeleton4Xi': None, 'object': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'sense', 13: 2, 14: '-0x-0y-0z',
            #                         15: '27x26y-11z', 16: '21x74y-45z', 17: '15x43y-19z', 18: '0x0y-39z', 19: 'import4xi.py'}, '8xi': {}, '4xi': {}}} 29x24y-11z
 
    except:        
        print("\n (Step 10Z2/33) OF ZAP0010THREE4XI *** FAILED TO EMBED NEXT AND PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION THREE")
        message2print = "{(Step 10Z2/33) failed" + "; kb0010three2put-failed-by-zap0010three4xi: " + str(kb0010three2put) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                                
    # -------------------------------------------------------------------------------------------------
    # (Step 21/33) PUT KNOWLEDGEBASE FOR LAYER 0010 OF DIRECTION THREE 
    # -------------------------------------------------------------------------------------------------                   
    try:
        queue0010three.put(kb0010three2put)
        ack0010put4three = True  
        if ack2debug is True:                                                                                                       # 
            print("\n (Step 21A/33) OF ZAP0010THREE4XI - SUCCEEDED TO PUT LAYER 0010 TO QUEUE: ", queue0010three, " KB2PUT: ", kb0010three2put)
            # 
       
        # minimize trace after module test:
        message2print = "{(Step 21B/33) put" + "; kb0010three2put-put-by-zap0010three4xi: " + str(kb0010three2put)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                          # 
                    
    except:                                                                                                                
        print("\n (Step 21C/33) OF ZAP0010THREE4XI *** FAILED TO SET LAYER 0010 TO QUEUE0010THREE: ", queue0010three, " KB2PUT: ", kb0010three2put)                                                                                                         
        message2print = "{(Step 21C/33) failed" + "; queue0010three-put-failed-by-zap0010three4xi: " + str(queue0010three.put) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
           
    # -------------------------------------------------------------------------------------------------
    # (Step 20/33) MESSAGE ABOUT PUT OF KNOWLEDGEBASE FOR LAYER 0010 OF DIRECTION THREE 
    # -------------------------------------------------------------------------------------------------   
    if ack2debug is True:
        print("\n (Step 20A/33) OF ZAP0010THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL0010THREE: ", publisher_channel0010three)
                                                                                                                                    # 
    if ack0010put4three is True:
        message2send4three = "<ack0010put4three4xi>layer0010three</ack0010put4three4xi>"
    else:
        message2send4three = "<nack0010put4three4xi>layer0010three</nack0010put4three4xi>" 
    message2print = "{(Step 20B/33) set" + "; message2send4three-set-by-zap0010three4xi to: " + str(message2send4three)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #       
     
                
    # -------------------------------------------------------------------------------------------------
    # (Step 21/33) SEND MESSAGE ABOUT PUT OF KNOWLEDGEBASE FOR LAYER 0010 OF DIRECTION THREE 
    # -------------------------------------------------------------------------------------------------                        
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        publisher_channel0010three.send(message2send4three)
        if ack2debug is True:     
            print("(Step 21A/33) OF ZAP0010THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel0010three, " - TIME: ", time4xi()) 
                                                                                                                                    # 
        message2print = "{(Step 21B/33) sent" + "; message2send4three-sent-by-zap0010three4xi: " + str(message2send4three)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                          #  
    except:
        print("(Step 21C/33) OF ZAP0010THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel0010three, " - TIME: ", time4xi()) 
        message2print = "{(Step 21C/33) failed" + "; message2send4three-failed-by-zap0010three4xi: " + str(message2send4three) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                          # 
        
         
    # -------------------------------------------------------------------------------------------------
    # (Step 22/33) RETURN QUEUE OF LAYER 0010 OF DIRECTION THREE 
    # -------------------------------------------------------------------------------------------------               
    if ack2debug is True:        
        print("\n (Step 22A/33) OF ZAP0010THREE4XI - RETURNING QUEUE OBJECT QUEUE0010THREE: ", queue0010three, " - TIME: ", time4xi()) 
         
    message2print = "{(Step 22B/33) returning" + "; queue0010three-returning-by-zap0010three4xi: " + str(queue0010three) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                              # 
        
    return queue0010three    
        
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   zap2actor4xi.py
#   test_zap2actor4xi.py
#   test_zap2actor4xi.txt
#   sense-test-zap2actor4xi.xml
#   reason-test-zap2actor4xi.xml
#   ace-test-zap2actor4xi4xi.xml
#   scope-sense*4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of zap0010three4xi.py                           
# ------------------------------------------------------------------------------------------------- 
#"
#/>
